{xDEFINE PERTURBADO}
{xDEFINE RESTO_MINCOSTO}
{$DEFINE DUMP_TEXT_SIMRES}
{$DEFINE  DUMP_TEXT_OPTRES}
unit usalasdejuegoParaEditor;

interface
uses
		classes, sysutils,
    usalasdejuego,
		uActores,
    uCosaConNombre,
    xmatdefs,
    ucosa,
(*
		Math,
		uglobs,
		uranddispos,
		uauxiliares,
*)
    ufechas,
    uDemandas, uGeneradores,
		uArcos, uNodos,
    uComercioInternacional,
		uFuentesAleatorias;


function addActor(sala: TSalaDeJuego; actor : TActor) : boolean;
//Saca el actor de la sala y libera su memoria
procedure eliminarActor(sala: TSalaDeJuego; var actor : TActor);
//Saca el actor de la sala sin liberar su memoria
procedure quitarActor(sala: TSalaDeJuego; actor : TActor);

function nombreRepetido(sala: TSalaDeJuego; cosaConNombreEditando: TCosaConNombre; nombre: String; tipoCosaConNombre: TClaseDeCosaConNombre): boolean;
//tipoActor puede ser 'generador', 'demanda', 'arco' o 'nodo', sino se lanza una excepcion
//retorna true si la lista de actores correspondiente contiene un actor con el mismo nombre
//que no sea actorEditando. Si actorEditando es nil retorna true si la lista
//de actores correspondiente conitene un actor con el mismo nombre
function buscarCosaConNombre(sala: TSalaDeJuego; nombre, clase : String) : TCosaConNombre;
//Resuelve todas las referencias A actores o cosas que se encuentren en la sala.
//No confundir con resuelve las referencias DE actores en la sala.
//si eliminarNoEncontradas es false Retorna la cantidad de referencias que no se resolvieron
//si eliminarNoEncontradas es true, aquellas referencias que no se puedan resolver
//son ELIMINADAS de la lista de referencias, asignadas a NIL, y la funcin retorna 0
function resolverReferenciasContraSala(sala : TSalaDeJuego ; eliminarNoEncontradas : boolean) : Integer;
//Igual que resolverReferenciasContraSala pero solo resuelve las referencias de cosa
//function resolverReferenciasDeCosaContraSala(cosa : TCosa ; sala : TSalaDeJuego; eliminarNoEncontradas : boolean) : Integer;

function demandaFirme(sala: TSalaDeJuego ) : NReal;
function potenciaFirme( sala: TSalaDeJuego ) : NReal;
function Clonar_Y_ResolverReferencias(sala: TSalaDeJuego; cosaAClonar : TCosa) : TCosa;

function existeReferenciaALaCosaConNombre(cosaConNombre: TCosaConNombre; sala: TSalaDeJuego) : boolean;

procedure AlInicio;
procedure AlFinal;

implementation

function addActor(sala: TSalaDeJuego; actor : TActor) : boolean;
var
	aux : Integer;
	lista : TListaDeCosasConNombre;
begin
	if actor is TGenerador then	lista := sala.Gens
	else if actor is TDemanda then lista := sala.Dems
	else if actor is TNodo then lista := sala.Nods
	else if actor is TArco then lista := sala.Arcs
	else if (actor is TComercioInternacional) then lista := sala.ComercioInternacional
	else
		Raise Exception.Create('uSalasDeJuegoParaEditor.addActor: El actor ' + actor.ClaseNombre + ' no pertenece a ningun grupo de actores');

	if not lista.find(actor.nombre, aux) then
  begin
		lista.Add(actor);
		sala.listaActores.Add(actor);
		result := true;
  end
	else
		result := false
end;

procedure eliminarActor(sala: TSalaDeJuego; var actor : TActor);
var
	lista : TListaDeCosas;
begin
	if actor is TGenerador then	lista := sala.Gens
	else if actor is TDemanda then lista := sala.Dems
	else if actor is TNodo then lista := sala.Nods
	else if actor is TArco then lista := sala.Arcs
  else if actor is TComercioInternacional then lista := sala.ComercioInternacional
	else
		Raise Exception.Create('El actor ' + actor.ClaseNombre + ' no pertenece a ningun grupo de actores');
	lista.Remove(actor);
	sala.listaActores.Remove(actor);
	actor.free;
end;

procedure quitarActor( sala: TSalaDeJuego; actor : TActor);
var
	lista : TListaDeCosas;
begin
	if actor is TGenerador then	lista := sala.Gens
	else if actor is TDemanda then lista := sala.Dems
	else if actor is TNodo then lista := sala.Nods
	else if actor is TArco then lista := sala.Arcs
	else if actor is TComercioInternacional then lista := sala.ComercioInternacional
	else
		Raise Exception.Create('El actor ' + actor.ClaseNombre + ' no pertenece a ningun grupo de actores');
	lista.Remove(actor);
	sala.listaActores.Remove(actor);
end;

function nombreRepetido(sala: TSalaDeJuego; cosaConNombreEditando: TCosaConNombre; nombre: String; tipoCosaConNombre: TClaseDeCosaConNombre): boolean;
var
  i, posCosa: Integer;
begin
  posCosa:= -1;
  for i:= 0 to sala.listaActores.Count -1 do
    if (sala.listaActores[i] <> cosaConNombreEditando) and
       (TActor(sala.listaActores[i]).nombre = nombre) then
    begin
      posCosa:= i;
      break;
    end;
  if posCosa = -1 then
  for i:= 0 to sala.listaFuentes.Count -1 do
    if (sala.listaFuentes[i] <> cosaConNombreEditando) and
       (TFuenteAleatoria(sala.listaFuentes[i]).nombre = nombre) then
    begin
      posCosa:= i;
      break;
    end;
  //TODO faltan los monitores

  result:= posCosa <> -1;
end;

function buscarCosaConNombre(sala: TSalaDeJuego; nombre, clase : String) : TCosaConNombre;
var
	cosa : TCosaConNombre;
	ipos : Integer;
begin
	cosa := NIL;
	if (sala.globs.ClassName = clase) and (sala.globs.nombre = nombre) then
		cosa := sala.globs
	else if sala.listaActores.find(clase, nombre, ipos) then
		cosa := TCosaConNombre(sala.listaActores[ipos]);
	result := cosa;
end;

function resolverReferenciasContraSala(sala : TSalaDeJuego ; eliminarNoEncontradas : boolean) : Integer;
var
  lstGlobs: TListaDeCosasConNombre;
  res : Integer;
begin
  if uCosaConNombre.referenciasSinResolver > 0 then
  begin
    lstGlobs:= TListaDeCosasConNombre.Create('Aux');
    lstGlobs.Add(sala.globs);
    uCosaConNombre.resolver_referencias(lstGlobs);
    uCosaConNombre.resolver_referencias(sala.listaActores);
    res:= uCosaConNombre.resolver_referencias(sala.listaFuentes);
    lstGlobs.FreeSinElemenentos;

    if eliminarNoEncontradas then
      uCosaConNombre.LimpiarReferencias;

    result:= res;
  end
  else
    Result:= 0;
end;

{function resolverReferenciasDeCosaContraSala(cosa : TCosa ; sala : TSalaDeJuego; eliminarNoEncontradas : boolean) : Integer;
var
  cosasEnLaSala : TListaDeCosasConNombre;
  i, n, refsSinResolver : Integer;
begin
  if uCosaConNombre.referenciasSinResolver > 0 then
  begin
    cosasEnLaSala:= TListaDeCosasConNombre.Create('Aux');
    n:= sala.listaActores.Count +
        sala.listaFuentes.Count +
        sala.Funcs.Count;
    cosasEnLaSala.Capacity:= n;
    for i:= 0 to sala.listaActores.Count - 1 do
      cosasEnLaSala.Add(TActor(sala.listaActores[i]));
    for i:= 0 to sala.listaFuentes.Count - 1 do
      cosasEnLaSala.Add(TFuenteAleatoria(sala.listaFuentes[i]));
    for i := 0 to sala.funcs.Count - 1 do
      cosasEnLaSala.Add(TFuncion(sala.Funcs[i]));
//    if cosa is TCosaConNombre then
//      cosasEnLaSala.Add(TCosaConNombre(cosa));
    refsSinResolver:= uCosaConNombre.resolver_referenciasDeCosa(cosa, cosasEnLaSala);
    cosasEnLaSala.FreeSinElemenentos;
    if eliminarNoEncontradas then
      uCosaConNombre.eliminar_referencias_del(cosa);

    result:= refsSinResolver;
  end
  else
    Result:= 0;
end;}

function demandaFirme (sala: TSalaDeJuego ): NReal;
var
	i : Integer;
	resultado : NReal;
begin
	resultado := 0;
	if sala.Dems.Count > 0 then
		begin
		for i := 0 to sala.Dems.Count -1 do
			resultado := resultado + TActor(sala.dems[i]).potenciaFirme;
		end;
	result := resultado
end;

function potenciaFirme(sala: TSalaDeJuego ): NReal;
var
	i : Integer;
	resultado : NReal;
begin
	resultado := 0;
	for i := 0 to sala.gens.Count -1 do
		resultado := resultado + TActor(sala.gens[i]).potenciaFirme;
	Result := resultado
end;

function Clonar_Y_ResolverReferencias(sala: TSalaDeJuego; cosaAClonar : TCosa) : TCosa;
var
  aux : TCosa;
begin
  assert(uCosaConNombre.referenciasSinResolver = 0);
  aux := cosaAClonar.Create_Clone;
  resolverReferenciasContraSala(sala, false);
  assert(uCosaConNombre.referenciasSinResolver = 0);
  result := aux;
end;

function existeReferenciaALaCosaConNombre(cosaConNombre: TCosaConNombre; sala: TSalaDeJuego) : boolean;
var
  salaAux: TSalaDeJuego;
  res: boolean;
begin
  assert(uCosaConNombre.referenciasSinResolver = 0, 'usalasdejuegoParaEditor.existeReferenciaALaCosaConNombre: quedan referencias sin resolver en la sala');
  salaAux:= TSalaDeJuego(sala.Create_Clone);
  res:= uCosaConNombre.existeReferencia_al(cosaConNombre);
  salaAux.Free;
  uCosaConNombre.LimpiarReferencias;
  result:= res;
end;

procedure AlInicio;
begin
//	registrarClaseDeCosa( TSalaDeJuegoParaEditor.ClassName, TSalaDeJuegoParaEditor, true );
end;

procedure AlFinal;
begin
end;

end.

